洛谷——P3576 [POI2014]MRO-Ant colony

P3576 [POI2014]MRO-Ant colony

题目描述

The ants are scavenging an abandoned ant hill in search of food.

The ant hill has nn chambers and n-1n−1 corridors connecting them.

We know that each chamber can be reached via a unique path from every other chamber.

In other words, the chambers and the corridors form a tree.

There is an entrance to the ant hill in every chamber with only one corridor leading into (or out of) it.

At each entry, there are gg groups of m_1,m_2,\cdots,m_gm?1??,m?2??,?,m?g?? ants respectively.

These groups will enter the ant hill one after another, each successive group entering once there are no ants inside.

Inside the hill, the ants explore it in the following way:

  • Upon entering a chamber with dd outgoing corridors yet unexplored by the group,the group divides into dd groups of equal size. Each newly created group follows one of the d corridors.If d=0d=0, then the group exits the ant hill.
  • If the ants cannot divide into equal groups, then the stronger ants eat the weaker until a perfect division is possible.Note that such a division is always possible since eventually the number of ants drops down to zero.Nothing can stop the ants from allowing divisibility - in particular, an ant can eat itself, and the last one remaining will do so if the group is smaller than dd.

The following figure depicts mm ants upon entering a chamber with three outgoing unexplored corridors, dividing themselves into three (equal) groups of \left \lfloor m/3 \right \rfloor⌊m/3⌋ ants each.

A hungry anteater dug into one of the corridors and can now eat all the ants passing through it.

However, just like the ants, the anteater is very picky when it comes to numbers.

It will devour a passing group if and only if it consists of exactly kk ants.

We want to know how many ants the anteater will eat.

给一棵树,对于每个叶子节点,都有g群蚂蚁要从外面进来,每群蚂蚁在行进过程中只要碰到岔路,就将平均地分成岔路口数-1那么多份,然后平均地走向剩下的那些岔路口,余下的蚂蚁自动消失,树上有一个关键边,假如有一群蚂蚁通过了这条边且数量恰好为k,这k只蚂蚁就被吃掉,问一共有多少只蚂蚁被吃掉

输入输出格式

输入格式:

The first line of the standard input contains three integers nn, gg, kk(2\le n,g\le 1\ 000\ 0002≤n,g≤1 000 000, 1\le k\le 10^91≤k≤10?9??), separated by single spaces.

These specify the number of chambers, the number of ant groups and the number of ants the anteater devours at once. The chambers are numbered from 1 to nn.

The second line contains gg integers m_1,m_2,\cdots,m_gm?1??,m?2??,?,m?g?? (1\le m_i\le 10^91≤m?i??≤10?9??), separated by single spaces, where m_im?i?? gives the number of ants in the ii-th group at every entrance to the ant hill. The n-1n−1 lines that follow describe the corridors within the ant hill;the ii-th such line contains two integers a_ia?i??,b_ib?i?? (1\le a_i,b_i\le n1≤a?i??,b?i??≤n), separated by a single space, that indicate that the chambers no. a_ia?i?? and b_ib?i?? are linked by a corridor. The anteater has dug into the corridor that appears first on input.

输出格式:

Your program should print to the standard output a single line containing a single integer: the number of ants eaten by the anteater.

输入输出样例

输入样例#1:

7 5 3
3 4 1 9 11
1 2
1 4
4 3
4 5
4 6
6 7

输出样例#1:

21

说明

给一棵树,对于每个叶子节点,都有g群蚂蚁要从外面进来,每群蚂蚁在行进过程中只要碰到岔路,就将平均地分成岔路口数-1那么多份,然后平均地走向剩下的那些岔路口,余下的蚂蚁自动消失,树上有一个关键边,假如有一群蚂蚁通过了这条边且数量恰好为k,这k只蚂蚁就被吃掉,问一共有多少只蚂蚁被吃掉

树形dp

O(≧口≦)O做了一晚上、、、

我们会发现一个很严肃的问题,如果我们从子节点开始做的话会非常难处理(反正蒟蒻表示我不会、、、)

既然正着不会,我们就倒着搞吧、、其次他说的是通过一条边的数量为k,这k只蚂蚁都会被吃掉。然而我们如果直接用边来进行运算的话,既然这样我们直接将边改为这条边的两个节点,然后以这两个节点为根节点,将原来的树处理成两棵树。然后就可以在这两棵树上乱搞了

如图所示:在1~2这条边上如果有k只蚂蚁经过的时候这k只蚂蚁会被吃掉

我们将上面的两棵树抽离成两颗一颗以1为根节点,一棵以2为根节点。

对于每一颗树我们从根节点开始往下进行搜索,更新每一个节点的父亲节点,如果这个点的父亲节点与他相连出去的节点不相同,那么将与他相连节点的父亲节点为当前节点。

我们看上面的图,如果要是蚂蚁经过1~2这条边上的时候蚂蚁的数量达到k时1号节点·与2好节点处的蚂蚁数量也就要为k。

然后我们在从这个各节点倒着计算他下面的节点蚂蚁的数量

我们知道进入蚂蚁的节点一定是子节点,然后每一个子节点往其他的分支那平分蚂蚁,他评分出来的蚂蚁一定是有一波要进入他的父亲节点。这样的话我们可以直接根据他的父亲节点的蚂蚁数目推出当前节点的蚂蚁数目,我们这个地方是不可能求出准确值的,因为他在平分的时候是下取整的。所以我们只能求出一个子节点的蚂蚁数目的范围。

子节点的蚂蚁的数目等于它的父节点的;连出去的边的条数*父节点的蚂蚁个数。

看这个图,你可以发现一个规律它的父节点连出去的边的条数正好等于它的父节点的入读。我们可以在进行dfs的时候处理处每一个点的父亲节点以及该点的入读、

蚂蚁平分,子节点最少的蚂蚁的个数为他父亲节点的蚂蚁的数量*父亲节点的入读,也就是说没有蚂蚁被消灭。最多的蚂蚁的数量为还差一个蚂蚁就可以让每一个分支在多分一只蚂蚁了,极为maxn[t]=(sum[now]+1)*out[now]-1

然后dfs结束的条件的为他已经搜索到最后一层子节点了。当minn[to[i]]<=m[g]是说明还没有到达根节点。

然后我们可以处理处到达叶子节点的时候的蚂蚁的最多数量跟最少数量,然后在判断有多少组蚂蚁满足要求。

最后的可以吃到的蚂蚁的数量为k*满足条件的蚂蚁的组数

#include<cstdio>
#include<cstring>
#include<cstdlib>
#include<iostream>
#include<algorithm>
#define N 1100000
#define ll long long
using namespace std;
int n,g,k,x,y,sx,sy,tot;
int fa[N],in[N],head[N];
ll s[N],maxn[N],minn[N],ans;
int read()
{
    int x=0,f=1; char ch=getchar();
    while(ch<‘0‘||ch>‘9‘){if(ch==‘-‘)f=-1; ch=getchar();}
    while(ch>=‘0‘&&ch<=‘9‘){x=x*10+ch-‘0‘; ch=getchar();}
    return x*f;
}
struct Edge
{
    int to,from,next;
}edge[N<<1];
int add(int x,int y)
{
    tot++;
    edge[tot].to=y;
    edge[tot].next=head[x];
    head[x]=tot;
}
int dfs(int now)
{
    for(int i=head[now];i;i=edge[i].next)
    {
        int t=edge[i].to;
        if(fa[now]!=t)
        {
            fa[t]=now;
            in[now]++;
         }
    }
    for(int i=head[now];i;i=edge[i].next)
    {
        int t=edge[i].to;
        if(fa[now]!=t)
        {
            minn[t]=minn[now]*in[now];
            maxn[t]=(maxn[now]+1)*in[now]-1;
            maxn[t]=min(maxn[t],s[g]);
            if(minn[t]<=s[g]) dfs(t);
        }
    }
}
ll erfen(ll x)
{
    int l=1,r=g,ans1=0;
    while(l<=r)
    {
        int mid=(l+r)>>1;
        if(s[mid]<x)
        {
            ans1=mid;
            l=mid+1;
        }
        else r=mid-1;
    }
    return ans1;
}
int main()
{
    n=read(),g=read(),k=read();
    for(int i=1;i<=g;i++) scanf("%lld",&s[i]);
    sort(s+1,s+1+g);
    sx=read(),sy=read();
    for(int i=2;i<n;i++)
    {
        x=read(),y=read();
        add(x,y),add(y,x);
    }
    minn[sx]=minn[sy]=maxn[sx]=maxn[sy]=k;
    dfs(sx),dfs(sy);
    for(int i=1;i<=n;i++)
     if(!in[i])
      ans+=erfen(maxn[i]+1)-erfen(minn[i]);
    printf("%lld",ans*k);
    return 0;
}
时间: 2024-11-15 06:00:57

洛谷——P3576 [POI2014]MRO-Ant colony的相关文章

洛谷 P3576 [POI2014]MRO-Ant colony

P3576 [POI2014]MRO-Ant colony 题目描述 The ants are scavenging an abandoned ant hill in search of food. The ant hill has nn chambers and n-1n−1 corridors connecting them. We know that each chamber can be reached via a unique path from every other chamber

洛谷—— P3576 [POI2014]MRO-Ant colony

https://www.luogu.org/problem/show?pid=3576 题目描述 The ants are scavenging an abandoned ant hill in search of food. The ant hill has nn chambers and n-1n−1 corridors connecting them. We know that each chamber can be reached via a unique path from every

洛谷 P2709 BZOJ 3781 小B的询问

题目描述 小B有一个序列,包含N个1~K之间的整数.他一共有M个询问,每个询问给定一个区间[L..R],求Sigma(c(i)^2)的值,其中i的值从1到K,其中c(i)表示数字i在[L..R]中的重复次数.小B请你帮助他回答询问. 输入输出格式 输入格式: 第一行,三个整数N.M.K. 第二行,N个整数,表示小B的序列. 接下来的M行,每行两个整数L.R. 输出格式: M行,每行一个整数,其中第i行的整数表示第i个询问的答案. 输入输出样例 输入样例#1: 6 4 3 1 3 2 1 1 3

洛谷1231 教辅的组成

洛谷1231 教辅的组成 https://www.luogu.org/problem/show?pid=1231 题目背景 滚粗了的HansBug在收拾旧语文书,然而他发现了什么奇妙的东西. 题目描述 蒟蒻HansBug在一本语文书里面发现了一本答案,然而他却明明记得这书应该还包含一份练习题.然而出现在他眼前的书多得数不胜数,其中有书,有答案,有练习册.已知一个完整的书册均应该包含且仅包含一本书.一本练习册和一份答案,然而现在全都乱做了一团.许多书上面的字迹都已经模糊了,然而HansBug还是可

洛谷教主花园dp

洛谷-教主的花园-动态规划 题目描述 教主有着一个环形的花园,他想在花园周围均匀地种上n棵树,但是教主花园的土壤很特别,每个位置适合种的树都不一样,一些树可能会因为不适合这个位置的土壤而损失观赏价值. 教主最喜欢3种树,这3种树的高度分别为10,20,30.教主希望这一圈树种得有层次感,所以任何一个位置的树要比它相邻的两棵树的高度都高或者都低,并且在此条件下,教主想要你设计出一套方案,使得观赏价值之和最高. 输入输出格式 输入格式: 输入文件garden.in的第1行为一个正整数n,表示需要种的

洛谷 P2801 教主的魔法 题解

此文为博主原创题解,转载时请通知博主,并把原文链接放在正文醒目位置. 题目链接:https://www.luogu.org/problem/show?pid=2801 题目描述 教主最近学会了一种神奇的魔法,能够使人长高.于是他准备演示给XMYZ信息组每个英雄看.于是N个英雄们又一次聚集在了一起,这次他们排成了一列,被编号为1.2.…….N. 每个人的身高一开始都是不超过1000的正整数.教主的魔法每次可以把闭区间[L, R](1≤L≤R≤N)内的英雄的身高全部加上一个整数W.(虽然L=R时并不

洛谷P1466 集合 Subset Sums

洛谷P1466 集合 Subset Sums这题可以看成是背包问题 用空间为 1--n 的物品恰好填充总空间一半的空间 有几种方案 01 背包问题 1.注意因为两个交换一下算同一种方案,所以最终 要 f [ v ] / 2 2.要开 long long 1 #include <cstdio> 2 #include <cstdlib> 3 #include <cmath> 4 #include <cstring> 5 #include <string&g

洛谷P1160 队列安排 链表

洛谷P1160 队列安排   链表 1 #include <cstdio> 2 #include <cstring> 3 #include <cmath> 4 #include <cstdlib> 5 #include <string> 6 #include <algorithm> 7 #include <iomanip> 8 #include <iostream> 9 using namespace std

洛谷 P3367 并查集模板

#include<cstdio> using namespace std; int n,m,p; int father[2000001]; int find(int x) { if(father[x]!=x) father[x]=find(father[x]); return father[x]; } void unionn(int i,int j) { father[j]=i; } int main() { scanf("%d%d",&n,&m); for